Drawing Workbench/sv: Difference between revisions

From FreeCAD Documentation
(Created page with "=== Komma åt bitarna ===")
(Updating to match new version of source page)
 
(35 intermediate revisions by 5 users not shown)
Line 1: Line 1:
<languages/>
Ritnings modulen tillåter dig att lägga ut ditt 3D arbete på papper. Det är, att lägga vyer av dina modeller i ett 2D fönster osh att sätta in det fönstret i en ritning, till exempel ett ark med en ram, en titel och din logotyp och slutligen skriva ut det arket. Ritningsmodulen är för närvarande under konstruktion och är mer eller mindre en teknologisk förhandstitt!


{{Docnav
== Gränssnittsverktyg ==
|
|
|IconL=
|IconR=
}}


{{VeryImportantMessage|The '''Drawing Workbench''' is no longer included after version 0.20.<br>
{{Drawing Tools/sv}}
The [[TechDraw_Workbench|TechDraw Workbench]] is its more advanced replacement.}}


[[Image:Workbench_Drawing.svg|thumb|128px|Drawing workbench icon]]


== Introduction ==
'''Note'''
The [[Draft Module]] has its own [[Draft_Drawing]] too to place Draft objects on paper. It has a couple of extra capabilities over the standard Drawing tools, and supports specific objects like [[Draft Dimension|Draft dimensions]].


Ritnings modulen tillåter dig att lägga ut ditt 3D arbete på papper. Det är, att lägga vyer av dina modeller i ett 2D fönster osh att sätta in det fönstret i en ritning, till exempel ett ark med en ram, en titel och din logotyp och slutligen skriva ut det arket. Ritningsmodulen är för närvarande under konstruktion och är mer eller mindre en teknologisk förhandstitt!


{{TOCright}}
[[Image:Drawing_extraction.png|800px]]
[[Image:Drawing_extraction.png|600px]]


<span id="Tools"></span>
I bilden så ser du huvudkoncepten av Ritningsmodulen. Dokumentet innehåller ett formobjekt (Schenkel) som vi vill göra en ritning av. Därför så är en "Sida" skapad. Sidan fås genom en mall, i detta fall "A3_Landskap" mallen. Mallen är ett SVG dokument som kan innehålla din vanliga sidram, din logotyp eller så den överensstämmer med dina presentationsstandarder.
== Gränssnittsverktyg ==


Detta är verktyg för att skapa, konfigurera och exportera 2D ritningsark
I denna sida så kan vi sätta in en eller fler vyer. Varje vy har en position på sidan (Egenskaper X,Y), en skalfaktor (Egenskap skala) och ytterligare egenskaper. Varje gång som sidan ,eller vyn, eller det refererade objektet ändras så regenereras sidan och visningen uppdateras.


* [[Image:Drawing_New.png|32px]] [[Drawing_Open_SVG|Open scalable vector graphic]]: Opens a drawing sheet previously saved as an SVG file
== Skript ==


* [[Image:Drawing_Landscape_A3.png|32px]] [[Drawing_Landscape_A3|New A3 landscape drawing]]: Creates a new drawing sheet from FreeCAD's default A3 template
För tillfället så är arbetsflödet för slutanvändaren väldigt begränsat, så skript API't är intressantare. Här följer exempel på hur man använder skript API't för ritningsmodulen.


* [[Image:Drawing_View.png|32px]] [[Drawing_View|Insert a view]]: Inserts a view of the selected object in the active drawing sheet
Here a script that can easily fill the [[Macro_CartoucheFC]] leaf FreeCAD A3_Landscape.


* [[Image:Drawing_Annotation.png|32px]] [[Drawing_Annotation|Annotation]]: Adds an annotation to the current drawing sheet
=== Enkelt exempel ===


* [[Image:Drawing_Clip.png|32px]] [[Drawing_Clip|Clip]]: Adds a clip group to the current drawing sheet
Först av allt så behöver du Del och Ritningsmodulen:
<syntaxhighlight>
import FreeCAD, Part, Drawing
</syntaxhighlight>
Skapa en liten exempeldel:
<syntaxhighlight>
Part.show(Part.makeBox(100,100,100).cut(Part.makeCylinder(80,100)).cut(Part.makeBox(90,40,100)).cut(Part.makeBox(20,85,100)))
</syntaxhighlight>
Direkt projektion. G0 innebär hård kant, G1 är kontinuerlig tangent.
<syntaxhighlight>
Shape = App.ActiveDocument.Shape.Shape
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape)
print "visible edges:", len(visibleG0.Edges)
print "hidden edges:", len(hiddenG0.Edges)
</syntaxhighlight>
Allting projicerades på Z-planet:
<syntaxhighlight>
print "Bnd Box shape: X=",Shape.BoundBox.XLength," Y=",Shape.BoundBox.YLength," Z=",Shape.BoundBox.ZLength
print "Bnd Box project: X=",visibleG0.BoundBox.XLength," Y=",visibleG0.BoundBox.YLength," Z=",visibleG0.BoundBox.ZLength
</syntaxhighlight>
Annan projectionsvektor
<syntaxhighlight>
[visibleG0,visibleG1,hiddenG0,hiddenG1] = Drawing.project(Shape,App.Vector(1,1,1))
</syntaxhighlight>
Projicera till SVG
<syntaxhighlight>
resultSVG = Drawing.projectToSVG(Shape,App.Vector(1,1,1))
print resultSVG
</syntaxhighlight>
=== Det parametriska sättet ===


* [[Image:Drawing_Openbrowser.png|32px]] [[Drawing_Openbrowser|Open Browser]]: Opens a preview of the current sheet in the browser
Skapa kroppen
<syntaxhighlight>
import FreeCAD
import Part
import Drawing


* [[Image:Drawing_Orthoviews.png|32px]] [[Drawing_Orthoviews|Ortho Views]]: Automatically creates orthographic views of an object on the current drawing sheet
# Create three boxes and a cylinder
App.ActiveDocument.addObject("Part::Box","Box")
App.ActiveDocument.Box.Length=100.00
App.ActiveDocument.Box.Width=100.00
App.ActiveDocument.Box.Height=100.00


* [[Image:Drawing_Symbol.png|32px]] [[Drawing_Symbol|Symbol]]: Adds the contents of a SVG file as a symbol on the current drawing sheet
App.ActiveDocument.addObject("Part::Box","Box1")
App.ActiveDocument.Box1.Length=90.00
App.ActiveDocument.Box1.Width=40.00
App.ActiveDocument.Box1.Height=100.00


* [[Image:Drawing_DraftView.png|32px]] [[Draft_Drawing|Draft View]]: Inserts a special Draft view of the selected object in the current drawing sheet
App.ActiveDocument.addObject("Part::Box","Box2")
App.ActiveDocument.Box2.Length=20.00
App.ActiveDocument.Box2.Width=85.00
App.ActiveDocument.Box2.Height=100.00


* [[Image:Drawing_SpreadsheetView.png|32px]] [[Drawing_SpreadsheetView|Spreadsheet View]]: Inserts a view of a selected spreadsheet in the current drawing sheet
App.ActiveDocument.addObject("Part::Cylinder","Cylinder")
App.ActiveDocument.Cylinder.Radius=80.00
App.ActiveDocument.Cylinder.Height=100.00
App.ActiveDocument.Cylinder.Angle=360.00
# Fuse two boxes and the cylinder
App.ActiveDocument.addObject("Part::Fuse","Fusion")
App.ActiveDocument.Fusion.Base = App.ActiveDocument.Cylinder
App.ActiveDocument.Fusion.Tool = App.ActiveDocument.Box1


* [[Image:Drawing_Save.png|32px]] [[Drawing_Save|Save sheet]]: Saves the current sheet as a SVG file
App.ActiveDocument.addObject("Part::Fuse","Fusion1")
App.ActiveDocument.Fusion1.Base = App.ActiveDocument.Box2
App.ActiveDocument.Fusion1.Tool = App.ActiveDocument.Fusion
# Cut the fused shapes from the first box
App.ActiveDocument.addObject("Part::Cut","Shape")
App.ActiveDocument.Shape.Base = App.ActiveDocument.Box
App.ActiveDocument.Shape.Tool = App.ActiveDocument.Fusion1
# Hide all the intermediate shapes
Gui.ActiveDocument.Box.Visibility=False
Gui.ActiveDocument.Box1.Visibility=False
Gui.ActiveDocument.Box2.Visibility=False
Gui.ActiveDocument.Cylinder.Visibility=False
Gui.ActiveDocument.Fusion.Visibility=False
Gui.ActiveDocument.Fusion1.Visibility=False
</syntaxhighlight>
Sätt in ett sid objekt och välj en mall
<syntaxhighlight>
App.ActiveDocument.addObject('Drawing::FeaturePage','Page')
App.ActiveDocument.Page.Template = App.getResourceDir()+'Mod/Drawing/Templates/A3_Landscape.svg'
</syntaxhighlight>
Skapa en vy på "Shape" objektet, definiera position och skala och sätt in den i en sida
<syntaxhighlight>
App.ActiveDocument.addObject('Drawing::FeatureViewPart','View')
App.ActiveDocument.View.Source = App.ActiveDocument.Shape
App.ActiveDocument.View.Direction = (0.0,0.0,1.0)
App.ActiveDocument.View.X = 10.0
App.ActiveDocument.View.Y = 10.0
App.ActiveDocument.Page.addObject(App.ActiveDocument.View)
</syntaxhighlight>
Skapa en andra vy på samma objekt men denna gång kommer vyn att vara roterad 90 grader.
<syntaxhighlight>
App.ActiveDocument.addObject('Drawing::FeatureViewPart','ViewRot')
App.ActiveDocument.ViewRot.Source = App.ActiveDocument.Shape
App.ActiveDocument.ViewRot.Direction = (0.0,0.0,1.0)
App.ActiveDocument.ViewRot.X = 290.0
App.ActiveDocument.ViewRot.Y = 30.0
App.ActiveDocument.ViewRot.Scale = 1.0
App.ActiveDocument.ViewRot.Rotation = 90.0
App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewRot)
</syntaxhighlight>
Skapa en tredje vy av samma objekt men med en isometrisk vyriktning. Gömda linjer aktiveras också.
<syntaxhighlight>
App.ActiveDocument.addObject('Drawing::FeatureViewPart','ViewIso')
App.ActiveDocument.ViewIso.Source = App.ActiveDocument.Shape
App.ActiveDocument.ViewIso.Direction = (1.0,1.0,1.0)
App.ActiveDocument.ViewIso.X = 335.0
App.ActiveDocument.ViewIso.Y = 140.0
App.ActiveDocument.ViewIso.ShowHiddenLines = True
App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewIso)
</syntaxhighlight>
Ändra något och uppdatera. Uppdateringsprocessen ändrar vyn och sidan.
<syntaxhighlight>
App.ActiveDocument.View.X = 30.0
App.ActiveDocument.View.Y = 30.0
App.ActiveDocument.View.Scale = 1.5
App.ActiveDocument.recompute()
</syntaxhighlight>
=== Komma åt bitarna ===


* [[Drawing_ProjectShape|Project Shape]]: Creates a projection of the selected object (Source) in the 3D view.
Get the SVG fragment of a single view
<syntaxhighlight>
ViewSVG = App.ActiveDocument.View.ViewResult
print ViewSVG
</syntaxhighlight>
Get the whole result page (it's a file in the document's temporary directory, only read permission)
<syntaxhighlight>
print "Resulting SVG document: ",App.ActiveDocument.Page.PageResult
file = open(App.ActiveDocument.Page.PageResult,"r")
print "Result page is ",len(file.readlines())," lines long"
</syntaxhighlight>
Important: free the file!
<syntaxhighlight>
del file
</syntaxhighlight>
Insert a view with your own content:
<syntaxhighlight>
App.ActiveDocument.addObject('Drawing::FeatureView','ViewSelf')
App.ActiveDocument.ViewSelf.ViewResult = """<g id="ViewSelf"
stroke="rgb(0, 0, 0)"
stroke-width="0.35"
stroke-linecap="butt"
stroke-linejoin="miter"
transform="translate(30,30)"
fill="#00cc00"
>


'''Note'''
<ellipse cx="40" cy="40" rx="30" ry="15"/>
The [[Draft Workbench]] has its own [[Draft_Drawing]] too to place Draft objects on paper. It has a couple of extra capabilities over the standard Drawing tools, and supports specific objects like [[Draft Dimension|Draft dimensions]].
</g>"""
App.ActiveDocument.Page.addObject(App.ActiveDocument.ViewSelf)
App.ActiveDocument.recompute()


I bilden så ser du huvudkoncepten av Ritningsmodulen. Dokumentet innehåller ett formobjekt (Schenkel) som vi vill göra en ritning av. Därför så är en "Sida" skapad. Sidan fås genom en mall, i detta fall "A3_Landskap" mallen. Mallen är ett SVG dokument som kan innehålla din vanliga sidram, din logotyp eller så den överensstämmer med dina presentationsstandarder.
del ViewSVG
</syntaxhighlight>
That leads to the following result:


I denna sida så kan vi sätta in en eller fler vyer. Varje vy har en position på sidan (Egenskaper X,Y), en skalfaktor (Egenskap skala) och ytterligare egenskaper. Varje gång som sidan ,eller vyn, eller det refererade objektet ändras så regenereras sidan och visningen uppdateras.
[[Image:DrawingScriptResult.jpg|800px]]


<span id="Scripting"></span>
=== General Dimensioning and Tolerancing ===
== Skript ==


För tillfället så är arbetsflödet för slutanvändaren väldigt begränsat, så skript API't är intressantare. Här följer exempel på hur man använder skript API't för ritningsmodulen.
Drawing dimensions an toleranecs are still under development but you can get some basic functionality with a bit of work.


See the [[Drawing API example]] page for a description of the functions used to create drawing pages and views.
First you need to get the gdtsvg python module from here (WARNING: This could be broken at any time!):


<span id="Templates"></span>
https://github.com/jcc242/FreeCAD
== Exempel ==


FreeCAD kommer med ett standardset med mallar, men du kan hitta fler på [[Drawing templates/sv|Ritningsmallar]] sidan.
To get a feature control frame, try out the following:
<syntaxhighlight>
import gdtsvg as g # Import the module, I like to give it an easy handle
ourFrame = g.ControlFrame("0","0", g.Perpendicularity(), ".5", g.Diameter(), g.ModifyingSymbols("M"), "A",
g.ModifyingSymbols("F"), "B", g.ModifyingSymbols("L"), "C", g.ModifyingSymbols("I"))
</syntaxhighlight>
Here is a good breakdown of the contents of a feature control frame: http://www.cadblog.net/adding-geometric-tolerances.htm


== Extending the Drawing Module ==
The parameters to pass to control frame are:
#X-coordinate in SVG-coordinate system (type string)
#Y-coordinate in SVG-coordinate system (type string)
#The desired geometric characteristic symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
#The tolerance (type string)
#(optional) The diameter symbol (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The condition modifying material (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The first datum (type string)
#(optional) The first datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The second datum (type string)
#(optional) The second datum's modifying condition (tuple, svg string as first, width of symbol as second, height of symbol as third)
#(optional) The third datum (type string)
#(optional) The third datum's material condition (tuple, svg string as first, width of symbol as second, height of symbol as third)


Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.
The ControlFrame function returns a type containing (svg string, overall width of control frame, overall height of control frame)'''


== Tutorials ==
To get a dimension, try out the following:
* [[Drawing_tutorial|Drawing tutorial]]
<syntaxhighlight>
* [[Drawing_Template_HowTo|Drawing Template HowTo]]
import gdtsvg
ourDimension = linearDimension(point1, point2, textpoint, dimensiontext, linestyle=getStyle("visible"),
arrowstyle=getStyle("filled"), textstyle=getStyle("text")
</syntaxhighlight>
Inputs for linear dimension are:
#point1, an (x,y) tuple with svg-coordinates, this is one of the points you would like to dimension between
#point2, an (x,y) tuple with svg-coordinates, this is the second point you would like to dimension between
#textpoint, an (x,y) tuple of svg-coordinates, this is where the text of your dimension will be
#dimensiontext, a string containing the text you want the dimension to say
#linestyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling the how the lines look
#arrowstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the arrows look
#textstyle, a string containing svg (i.e. css) styles, using the getStyle function to retrieve a preset string, for styling how the text looks


== Macros ==
With those two, you can proceed as above for displaying them on the drawing page. This module is very buggy and can be broken at any given moment, bug reports are welcome on the github page for now, or contact jcc242 on the forums if you post a bug somewhere else.


* {{MacroLink|Icon=Macro_Automatic_drawing.png|Macro_Automatic_drawing|Macro Automatic drawing}}: Allows the user to get the view of his object in a drawing with 4 different position (front,top,iso,right). Needs some modification to be perfectly effective.
== Templates ==


* {{MacroLink|Icon=Macro_CartoucheFC.png|Macro_CartoucheFC|Macro CartoucheFC}}: This GUI macro to fill simply all fields of the cartridge of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
FreeCAD comes bundled with a set of default templates, but you can find more on the [[Drawing templates]] page.


* {{MacroLink|Icon=Macro_CartoucheFC_2.png|Macro_CartoucheFC_2|Macro CartoucheFC 2}}: This GUI macro to fill simply all fields of the cartridge '''model 2''' of the plan implementation worksheet FreeCAD.
== Extending the Drawing Module ==


* {{MacroLink|Icon=Macro_CartoucheFC_Full.png|Macro_CartoucheFC_Full|Macro CartoucheFC Full}}: This GUI macro to fill simply all fields of the cartridge [[Misc_templates_Full|Misc templates Full]] of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
Some notes on the programming side of the drawing module will be added to the [[Drawing Documentation]] page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.


* {{MacroLink|Icon=Macro_Corner_shapes_wizard.png|Macro_Corner_shapes_wizard/update|Macro Corner shapes wizard/update}}: Pops up a dialog asking for the dimensions of your corner piece, then creates the object in the document and creates a page view with top, front and lateral views of the piece.
{{docnav|Part Module|Raytracing Module}}


== External links ==
[[Category:User Documentation]]

<languages/>
* [https://www.youtube.com/watch?v=1Hm5Zyjmjac Intro to mechanical drawing on Youtube - by Normal Universe]


<div class="mw-translate-fuzzy">
{{docnav/sv|Part Workbench/sv|Raytracing Workbench/sv}}
</div>

{{Drawing Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
[[Category:Obsolete Workbenches{{#translation:}}]]

Latest revision as of 08:47, 8 July 2023

The Drawing Workbench is no longer included after version 0.20.
The TechDraw Workbench is its more advanced replacement.
Drawing workbench icon

Introduction

Ritnings modulen tillåter dig att lägga ut ditt 3D arbete på papper. Det är, att lägga vyer av dina modeller i ett 2D fönster osh att sätta in det fönstret i en ritning, till exempel ett ark med en ram, en titel och din logotyp och slutligen skriva ut det arket. Ritningsmodulen är för närvarande under konstruktion och är mer eller mindre en teknologisk förhandstitt!

Gränssnittsverktyg

Detta är verktyg för att skapa, konfigurera och exportera 2D ritningsark

  • Insert a view: Inserts a view of the selected object in the active drawing sheet
  • Annotation: Adds an annotation to the current drawing sheet
  • Clip: Adds a clip group to the current drawing sheet
  • Open Browser: Opens a preview of the current sheet in the browser
  • Ortho Views: Automatically creates orthographic views of an object on the current drawing sheet
  • Symbol: Adds the contents of a SVG file as a symbol on the current drawing sheet
  • Draft View: Inserts a special Draft view of the selected object in the current drawing sheet
  • Spreadsheet View: Inserts a view of a selected spreadsheet in the current drawing sheet
  • Save sheet: Saves the current sheet as a SVG file
  • Project Shape: Creates a projection of the selected object (Source) in the 3D view.

Note The Draft Workbench has its own Draft_Drawing too to place Draft objects on paper. It has a couple of extra capabilities over the standard Drawing tools, and supports specific objects like Draft dimensions.

I bilden så ser du huvudkoncepten av Ritningsmodulen. Dokumentet innehåller ett formobjekt (Schenkel) som vi vill göra en ritning av. Därför så är en "Sida" skapad. Sidan fås genom en mall, i detta fall "A3_Landskap" mallen. Mallen är ett SVG dokument som kan innehålla din vanliga sidram, din logotyp eller så den överensstämmer med dina presentationsstandarder.

I denna sida så kan vi sätta in en eller fler vyer. Varje vy har en position på sidan (Egenskaper X,Y), en skalfaktor (Egenskap skala) och ytterligare egenskaper. Varje gång som sidan ,eller vyn, eller det refererade objektet ändras så regenereras sidan och visningen uppdateras.

Skript

För tillfället så är arbetsflödet för slutanvändaren väldigt begränsat, så skript API't är intressantare. Här följer exempel på hur man använder skript API't för ritningsmodulen.

See the Drawing API example page for a description of the functions used to create drawing pages and views.

Exempel

FreeCAD kommer med ett standardset med mallar, men du kan hitta fler på Ritningsmallar sidan.

Extending the Drawing Module

Some notes on the programming side of the drawing module will be added to the Drawing Documentation page. This is to help quickly understand how the drawing module works, enabling programmers to rapidly start programming for it.

Tutorials

Macros

  • Macro Automatic drawing: Allows the user to get the view of his object in a drawing with 4 different position (front,top,iso,right). Needs some modification to be perfectly effective.
  • Macro CartoucheFC: This GUI macro to fill simply all fields of the cartridge of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
  • Macro CartoucheFC 2: This GUI macro to fill simply all fields of the cartridge model 2 of the plan implementation worksheet FreeCAD.
  • Macro CartoucheFC Full: This GUI macro to fill simply all fields of the cartridge Misc templates Full of the plan implementation worksheet FreeCAD, the format of the date and the symbol of the projection mode adapt to the EU region or US selected.
  • Macro Corner shapes wizard/update: Pops up a dialog asking for the dimensions of your corner piece, then creates the object in the document and creates a page view with top, front and lateral views of the piece.

External links


Part Workbench/sv
Raytracing Workbench/sv